// zlib License. Warzone2100. wz2100.net - official site. Made on the glhlib

#include "mipmaps.h"

ZoomOutTwice::ZoomOutTwice()
{
	level = 0;
	z_bool=true;
	SizeEnd = 1;
	firsttime = true;
}

int gluScaleImage(unsigned int format,int widthin, int heightin,unsigned char *datain,int widthout, int heightout,unsigned char *dataout)
{

	int dataAlignment=1;
	int isUseLinearOrPointSample=true;


	int components;		//Bits per pixel (BPP)
	int i, j, tempo;
	//sreal *tempin, *tempout;
	float sx, sy;
	float one=1.0;
	//sint sizein, sizeout;
	//sint rowstride;
	//uchar *ubptr;
	int ii, jj;
	////////////////////////
	/*switch(format)
	{
	case GL_RGB:
		components=3;
		break;
	case GL_RGBA:
		components=4;
		break;
	default:
		return -5;
	}*/
	__asm
	{
		mov		edx, format
		cmp		edx, GL_RGB
		je		Address_GL_RGB
		cmp		edx, GL_RGB8
		je		Address_GL_RGB
		cmp		edx, GL_RGBA
		je		Address_GL_RGBA
		cmp		edx, GL_RGBA8
		je		Address_GL_RGBA
	}
	return -5;
	__asm
	{
		Address_GL_RGB:
		mov		components, 3
		jmp		FormatExit
		Address_GL_RGBA:
		mov		components, 4
		//jmp		FormatExit
		FormatExit:
	}
	
	/*if(widthout>1)
		sx=sreal(widthin-1)/sreal(widthout-1);
	else
		sx=sreal(widthin-1);
	if(heightout>1)
		sy=sreal(heightin-1)/sreal(heightout-1);
	else
		sy=sreal(heightin-1);*/
	__asm
	{
		//Need some temporary sint here.
		//First if statement
		mov		ecx, widthin
		dec		ecx
		mov		i, ecx
		mov		edx, widthout
		cmp		edx, 1
		jle		JUMPPOINT_a_q22bx
		dec		edx
		mov		j, edx
		fild	i
		fidiv	j
		fstp	sx				; store into sx
		jmp		JUMPPOINT_a_q22bxsup
		JUMPPOINT_a_q22bx:
		fild	i				; have the FPU translate integer to sreal
		fstp	sx				; store into sx
		JUMPPOINT_a_q22bxsup:
		//Second if statement
		mov		ecx, heightin
		dec		ecx
		mov		i, ecx
		mov		edx, heightout
		cmp		edx, 1
		jle		JUMPPOINT_b_yy789
		dec		edx
		mov		j, edx
		fild	i
		fidiv	j
		fstp	sy				; store into sy
		jmp		JUMPPOINT_b_yy789sup
		JUMPPOINT_b_yy789:
		fild	i				; have the FPU translate integer to sreal
		fstp	sy				; store into sy
		JUMPPOINT_b_yy789sup:
	}
	/////////////////////////////

	//The FPU's default behavior on Intel is to round or even the value which
	//causes a problem for this algorithm since we need truncation, so we change the FPU
	//control register bit 11 and 10 from 00 to 11
	short old_FPU_Flag, new_FPU_Flag;	//Must be 16 bit (word)
	__asm
	{
		fstcw	old_FPU_Flag	; store control word
		mov		ax, old_FPU_Flag
		or		ax, 0x0C00		; set bit 11 and bit 10 to 11, which means truncate
		mov		new_FPU_Flag, ax
		fldcw	new_FPU_Flag	; load control word
	}

	if(dataAlignment==1)
	{
		if(isUseLinearOrPointSample==false)
		{
			//Gone use point sampling
			////////// DEBUG start /////////////////////////
			//Memory bounds check
			/*uchar *checking001, *checking002;
			checking001=datain+widthin*heightin*3;
			checking002=dataout+widthout*heightout*3;

			for(i=0; i<heightout; i++)
			{
				ii=i*sy;
				for(j=0; j<widthout; j++)
				{
					jj=j*sx;
					uchar *src=datain+(ii*widthin+jj)*components;
					uchar *dst=dataout+(i*widthout+j)*components;
					for(k=0; k<components; k++)
					{
						if(dst>=checking002)
						{
							MessageBox("Memory bound error (009zx)", "DEBUG", MB_OK);
							return 0;
						}
						if(src>=checking001)
						{
							MessageBox("Memory bound error (010zx)", "DEBUG", MB_OK);
							return 0;
						}
						*dst=*src;
						dst++;
						src++;
					}
				}
			}
			return 1;
			////////// DEBUG end /////////////////////////*/
			//Gone use point sampling
			/*if(components==3)
			{
				for(i=0; i<heightout; i++)
				{
					ii=sint(sreal(i)*sy);
					for(j=0; j<widthout; j++)
					{
						jj=sint(sreal(j)*sx);
						uchar *src=datain+(ii*widthin+jj)*3;
						uchar *dst=dataout+(i*widthout+j)*3;
						//For each component
						dst[0]=src[0];
						dst[1]=src[1];
						dst[2]=src[2];
					}
				}
			}
			else if(components==4)
			{
				for(i=0; i<heightout; i++)
				{
					ii=sint(sreal(i)*sy);
					for(j=0; j<widthout; j++)
					{
						jj=sint(sreal(j)*sx);
						uchar *src=datain+(ii*widthin+jj)*4;
						uchar *dst=dataout+(i*widthout+j)*4;
						//For each component
						dst[0]=src[0];
						dst[1]=src[1];
						dst[2]=src[2];
						dst[3]=src[3];
					}
				}
			}*/
			__asm
			{
				//ebx is dataout
				//ecx as i
				//edx as j
				mov		ebx, dataout
				cmp		components, 3
				jne		ThirtyTwoBits
				//This is the 24 bit version
				dec		heightout		; the last line of the image will be processed differently, this value will not be restored
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoops
				EnterLoop1:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	ii
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop1
				EnterLoop2:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	jj
				mov		esi, ii
				imul	esi, widthin
				add		esi, jj
				imul	esi, 3
				add		esi, datain
				mov		edi, i
				imul	edi, widthout
				add		edi, edx		; edx contains j
				imul	edi, 3
				add		edi, ebx
				//mov		ax, [esi]		; copy red and green component
				//mov		[edi], ax
				//mov		al, [esi+2]		; copy blue component
				//mov		[edi+2], al
				mov		eax, [esi]
				mov		[edi], eax			; copy 4 bytes
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2
				ExitLoop1:
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1
				//This is for the last line of the 24 bit image
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	ii
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoops
				EnterLoop2_spk:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	jj
				mov		esi, ii
				imul	esi, widthin
				add		esi, jj
				imul	esi, 3
				add		esi, datain
				mov		edi, i
				imul	edi, widthout
				add		edi, edx		; edx contains j
				imul	edi, 3
				add		edi, ebx
				mov		ax, [esi]		; copy red and green component
				mov		[edi], ax
				mov		al, [esi+2]		; copy blue component
				mov		[edi+2], al
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2_spk
				jmp		ExitLoops		; skip 32 bit section
				ThirtyTwoBits:
				//This is the 32 bit version
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoops
				EnterLoop1b:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	ii
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop1b
				EnterLoop2b:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	jj
				mov		esi, ii
				imul	esi, widthin
				add		esi, jj
				imul	esi, 4
				add		esi, datain
				mov		edi, ecx		; contains i
				imul	edi, widthout
				add		edi, edx		; contains j
				imul	edi, 4
				add		edi, ebx
				mov		eax, [esi]		; copy color
				mov		[edi], eax
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2b
				ExitLoop1b:
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1b
				ExitLoops:
			}
			
			//return 1;			//Success
			goto EndOf_glhScaleImage_asm386;
		}
		else //if(isUseLinearOrPointSample==TRUE)
		{
			__asm
			{
				//if((sx<1.0)&&(sy<1.0))
				fld		sx
				fcomp	one
				fnstsw	ax
				test	ah, 5
				jp		SkipIf_98
				fld		sy
				fcomp	one
				fnstsw	ax
				test	ah, 5
				jp		SkipIf_98
			}
			//Magnify both width and height:  use weighted sample of 4 pixels
			//**** In this code, floating point is used to do some of the calculations, but I will avoid
			//**** using the FPU and will stick to integer computation with some limited precision.
			int i0, i1, j0, j1, sum, sum2, sum3, sum4;
			//sint alpha, beta;		//These are suppose to be sreal in MESA code!
			float falpha, fbeta, foneminusalpha, foneminusbeta;//, s1, s2;
			unsigned char *src00, *src01, *src10, *src11;
			//uchar *check=dataout+widthout*heightout*components;
			//uchar *check2=datain+widthin*heightin*components;
			__asm
			{
				//ecx is i
				//edx is j
				cmp		components, 3
				jne		ThirtyTwoBits_66_78
				//24 bit section
				fld		one				; need this for later (1.0-falpha and 1.0 fbeta)
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitSuperly
				EnterLoop1_dashj:
				mov		i, ecx
				fild	i
				fmul	sy				; i0=sint(sreal(i)*sy);
				fist	i0				; keep the value in FPU register for later 
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_a
				dec		ebx
				mov		i1, ebx
				jmp		SkipIfStatement_firett_b
				SkipIfStatement_firett_a:
				mov		i1, eax
				SkipIfStatement_firett_b:
				fisub	i0					; this is falpha in st(0) - falpha=sreal(i)*sy-sreal(i0);
				fst		falpha
				fsub	st(0), st(1)		; this is foneminusalpha in st(0)
				fchs						; must change the sign
				fstp	foneminusalpha
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_sippy
				EnterLoop2_sippy:
				mov		j, edx
				fild	j
				fmul	sx				; sreal(j)*sx
				fist	j0				; keep this in FPU register for later
				//if(j0+1>=widthin)
				//	j1=widthin-1;
				//else
				//	j1=j0+1;
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_c
				dec		ebx
				mov		j1, ebx
				jmp		SkipIfStatement_firett_d
				SkipIfStatement_firett_c:
				mov		j1, eax
				SkipIfStatement_firett_d:
				fisub	j0
				fst		fbeta
				fsub	st(0), st(1)		; this is foneminusbeta in st(0)
				fchs						; must change the sign
				fstp	foneminusbeta
				//Now esi is src00
				//Now edi is src01
				//Now ebx is src10
				//Now ecx is src11
				//push	edx					; for safekeeping
				//push	ecx					; for safekeeping
				/*src00=datain+(i0*widthin+j0)*3;
						src01=datain+(i0*widthin+j1)*3;
						src10=datain+(i1*widthin+j0)*3;
						src11=datain+(i1*widthin+j1)*3;
						dst=dataout+(i*widthout+j)*3;*/
				mov		eax, datain			; temporary (not enough registers to make this algorithm efficient)
				mov		esi, i0
				mov		edi, esi			; make a copy of i0 for efficiency
				imul	esi, widthin
				add		esi, j0
				imul	esi, 3
				add		esi, eax
				imul	edi, widthin
				add		edi, j1
				imul	edi, 3
				add		edi, eax
				mov		ebx, i1
				mov		ecx, ebx			; make a copy if i1 for efficiency
				imul	ebx, widthin
				add		ebx, j0
				imul	ebx, 3
				add		ebx, eax
				imul	ecx, widthin
				add		ecx, j1
				imul	ecx, 3
				add		ecx, eax
				mov		eax, i				; dst=dataout+(i*widthout+j)*3;
				imul	eax, widthout
				add		eax, edx			; edx is j in this case
				imul	eax, 3
				add		eax, dataout
				mov		edx, eax			; now we have address in dst or in this case, edx
				mov		src00, esi
				mov		src01, edi
				mov		src10, ebx
				mov		src11, ecx
				//dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
				//			(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[0]*foneminusbeta
				mov		al, [edi]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[0]*foneminusbeta
				mov		al, [ecx]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx], al	; dst[0] contains result now
				//dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
				//			(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[1]*foneminusbeta
				mov		al, [edi+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[1]*foneminusbeta
				mov		al, [ecx+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+1], al	; dst[1] contains result now
				//dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
				//			(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[2]*foneminusbeta
				mov		al, [edi+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[2]*foneminusbeta
				mov		al, [ecx+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+2], al	; dst[2] contains result now
				//////
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2_sippy
				ExitLoop2_sippy:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_dashj
				jmp		ExitSuperly
				//32 bit section
				ThirtyTwoBits_66_78:
				fld		one				; need this for later (1.0-falpha and 1.0 fbeta)
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitSuperly
				EnterLoop1_dashj_b:
				mov		i, ecx
				fild	i
				fmul	sy
				fist	i0				; keep the value in FPU register for later
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_a_b
				dec		ebx
				mov		i1, ebx
				jmp		SkipIfStatement_firett_b_b
				SkipIfStatement_firett_a_b:
				mov		i1, eax
				SkipIfStatement_firett_b_b:
				fisub	i0
				fst		falpha
				fsub	st(0), st(1)		; this is foneminusalpha in st(0)
				fchs						; must change the sign
				fstp	foneminusalpha
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_sippy_b
				EnterLoop2_sippy_b:
				mov		j, edx
				fild	j
				fmul	sx
				fist	j0				; keep this in FPU register for later
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_c_b
				dec		ebx
				mov		j1, ebx
				jmp		SkipIfStatement_firett_d_b
				SkipIfStatement_firett_c_b:
				mov		j1, eax
				SkipIfStatement_firett_d_b:
				fisub	j0
				fst		fbeta
				fsub	st(0), st(1)		; this is foneminusbeta in st(0)
				fchs						; must change the sign
				fstp	foneminusbeta
				//Now esi is src00
				//Now edi is src01
				//Now ebx is src10
				//Now ecx is src11
				mov		eax, datain			; temporary (not enough registers to make this algorithm efficient)
				mov		esi, i0
				mov		edi, esi			; make a copy of i0 for efficiency
				imul	esi, widthin
				add		esi, j0
				imul	esi, 4				; 4 bytes per pixel
				add		esi, eax
				imul	edi, widthin
				add		edi, j1
				imul	edi, 4				; 4 bytes per pixel
				add		edi, eax
				mov		ebx, i1
				mov		ecx, ebx			; make a copy if i1 for efficiency
				imul	ebx, widthin
				add		ebx, j0
				imul	ebx, 4				; 4 bytes per pixel
				add		ebx, eax
				imul	ecx, widthin
				add		ecx, j1
				imul	ecx, 4				; 4 bytes per pixel
				add		ecx, eax
				mov		eax, i				; dst=dataout+(i*widthout+j)*4;
				imul	eax, widthout
				add		eax, edx			; edx is j
				imul	eax, 4				; 4 bytes per pixel
				add		eax, dataout
				mov		edx, eax			; now we have address in dst
				//dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
				//			(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[0]*foneminusbeta
				mov		al, [edi]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[0]*foneminusbeta
				mov		al, [ecx]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx], al	; dst[0] contains result now
				//dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
				//			(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;				
				mov		al, [esi+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[1]*foneminusbeta
				mov		al, [edi+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[1]*foneminusbeta
				mov		al, [ecx+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+1], al	; dst[1] contains result now
				mov		byte ptr[edx+1], al	; dst[1] contains result now
				//dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
				//			(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
				mov		al, [esi+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[2]*foneminusbeta
				mov		al, [edi+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[2]*foneminusbeta
				mov		al, [ecx+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+2], al	; dst[2] contains result now
				//dst[3]=(src00[3]*foneminusbeta+src01[3]*fbeta)*foneminusalpha+
				//			(src10[3]*foneminusbeta+src11[3]*fbeta)*falpha;
				mov		al, [esi+3]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[3]*foneminusbeta
				mov		al, [edi+3]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[3]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+3]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[3]*foneminusbeta
				mov		al, [ecx+3]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[3]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+3], al	; dst[3] contains result now
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2_sippy_b
				ExitLoop2_sippy_b:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_dashj_b
				ExitSuperly:
				fstp	st(0)
				//finit			; a single pop would suffice here

				jmp		Skip_Bunch_11
			}
			/*if(components==3)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					if(i0+1>=heightin)
						i1=heightin-1;
					else
						i1=i0+1;
					//i1=(i+1)*sy-EPSILON;
					falpha=sreal(i)*sy-sreal(i0);
					foneminusalpha=1.0-falpha;
					//alpha=i*intsy-i0*5000;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						if(j0+1>=widthin)
							j1=widthin-1;
						else
							j1=j0+1;
						//j1=(j+1)*sx-EPSILON;
						fbeta=sreal(j)*sx-sreal(j0);
						foneminusbeta=1.0-fbeta;
						//beta=j*intsx-j0*5000;
						//Compute weighted average of pixels in rect (i0,j0)-(i1,j1)
						src00=datain+(i0*widthin+j0)*3;
						src01=datain+(i0*widthin+j1)*3;
						src10=datain+(i1*widthin+j0)*3;
						src11=datain+(i1*widthin+j1)*3;
						dst=dataout+(i*widthout+j)*3;
						//For each component	
						//s1=src00[0]*(1.0-fbeta)+src01[0]*fbeta;
						//s2=src10[0]*(1.0-fbeta)+src11[0]*fbeta;
						dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
							(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
						//dst[0]=uchar(((sint(src00[0])*(5000-beta)+sint(src01[0])*beta)*(5000-alpha)+
						//                      (sint(src10[0])*(5000-beta)+sint(src11[0])*beta)*alpha)/25000000);
						
						//ERROR CHECKING CODE
						//if((sint(dst[0])<sint(c)-5)&&(sint(dst[0])>sint(c)+5))
						//	k++;
						//s1=src00[1]*(1.0-fbeta)+src01[1]*fbeta;
						//s2=src10[1]*(1.0-fbeta)+src11[1]*fbeta;
						dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
							(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;
						//dst[1]=uchar(((sint(src00[1])*(5000-beta)+sint(src01[1])*beta)*(5000-alpha)+
						//                      (sint(src10[1])*(5000-beta)+sint(src11[1])*beta)*alpha)/25000000);
						
						//s1=src00[2]*(1.0-fbeta)+src01[2]*fbeta;
						//s2=src10[2]*(1.0-fbeta)+src11[2]*fbeta;
						dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
							(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
						//dst[2]=uchar(((sint(src00[2])*(5000-beta)+sint(src01[2])*beta)*(5000-alpha)+
						//                      (sint(src10[2])*(5000-beta)+sint(src11[2])*beta)*alpha)/25000000);
						
					}
				}
				//schar b[200];
				//sprintf(b, "Number of errors is %d", k);
				//MessageBox(NULL, b, "DEBUG", MB_OK);
			}
			else if(components==4)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i1>=heightin)
						i1=heightin-1;
					//i1=(i+1)*sy-EPSILON;
					falpha=sreal(i)*sy-sreal(i0);
					foneminusalpha=1.0-falpha;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						fbeta=sreal(j)*sx-sreal(j0);
						foneminusbeta=1.0-fbeta;
						//Compute weighted average of pixels in rect (i0,j0)-(i1,j1)
						src00=datain+(i0*widthin+j0)*4;
						src01=datain+(i0*widthin+j1)*4;
						src10=datain+(i1*widthin+j0)*4;
						src11=datain+(i1*widthin+j1)*4;
						dst=dataout+(i*widthout+j)*4;
						//For each component	
						//s1=src00[0]*(1.0-beta)+src01[0]*beta;
						//s2=src10[0]*(1.0-beta)+src11[0]*beta;
						dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
							(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
						//dst[0]=uchar(((sint(src00[0])*(10000-beta)+sint(src01[0])*beta)*(10000-alpha)+
						//                      (sint(src10[0])*(10000-beta)+sint(src11[0])*beta)*alpha)/10000);
						//s1=src00[1]*(1.0-beta)+src01[1]*beta;
						//s2=src10[1]*(1.0-beta)+src11[1]*beta;
						dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
							(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;
						//dst[1]=uchar(((sint(src00[1])*(10000-beta)+sint(src01[1])*beta)*(10000-alpha)+
						//                     (sint(src10[1])*(10000-beta)+sint(src11[1])*beta)*alpha)/10000);
						//s1=src00[2]*(1.0-beta)+src01[2]*beta;
						//s2=src10[2]*(1.0-beta)+src11[2]*beta;
						dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
							(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
						//dst[2]=uchar(((sint(src00[2])*(10000-beta)+sint(src01[2])*beta)*(10000-alpha)+
						//	(sint(src10[2])*(10000-beta)+sint(src11[2])*beta)*alpha)/10000);
						//s1=src00[3]*(1.0-beta)+src01[3]*beta;
						//s2=src10[3]*(1.0-beta)+src11[3]*beta;
						dst[3]=(src00[3]*foneminusbeta+src01[3]*fbeta)*foneminusalpha+
							(src10[3]*foneminusbeta+src11[3]*fbeta)*falpha;
						//dst[3]=uchar(((sint(src00[3])*(10000-beta)+sint(src01[3])*beta)*(10000-alpha)+
						//                      (sint(src10[2])*(10000-beta)+sint(src11[2])*beta)*alpha)/10000);

					}
				}
			}*/
		
			//Shrink width and/or height:  use an unweighted box filter
			_asm
			{
				SkipIf_98:
				//ecx is i
				//edx is j
				cmp		components, 3
				jne		ThirtyTwoBits_xcd99
				//24 bit section
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoop1_a_stuzz
				EnterLoop1_a_stuzz:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	i0			; store as integer
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		Skipper_tyui
				dec		ebx
				mov		i1, ebx
				jmp		Skipper_tyui2
				Skipper_tyui:
				mov		i1, eax
				Skipper_tyui2:
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_c178
				Enter_Loop2_c178:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	j0
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		Skipper_tyui_zz
				dec		ebx
				mov		j1, ebx
				jmp		Skipper_tyui_zz2
				Skipper_tyui_zz:
				mov		j1, eax
				Skipper_tyui_zz2:
				mov		edi, i
				imul	edi, widthout
				add		edi, edx		; edx contains j
				imul	edi, 3
				add		edi, dataout
				//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
				//push	ecx				; need this for looping and is ii
				//push	edx				; need this for looping and is jj
				xor		ebx, ebx		; need for computing sum
				mov		sum, 0			; sum=0
				mov		sum2, 0
				mov		sum3, 0
				mov		ecx, i0
				cmp		ecx, i1
				jg		Exit_rtt1
				Enter_rtt1:
				mov		edx, j0
				cmp		edx, j1
				jg		Exit_rtt2
				Enter_rtt2:
				mov		esi, ecx
				imul	esi, widthin
				add		esi, edx
				imul	esi, 3
				add		esi, datain
				mov		bl, [esi]				; sum+=sint(*(datain+(ii*widthin+jj)*3));
				add		sum, ebx
				mov		bl, [esi+1]
				add		sum2, ebx
				mov		bl, [esi+2]
				add		sum3, ebx
				inc		edx
				cmp		edx, j1
				jle		Enter_rtt2
				Exit_rtt2:
				inc		ecx
				cmp		ecx, i1
				jle		Enter_rtt1
				Exit_rtt1:
				mov		eax, sum		; sum/=(j1-j0+1)*(i1-i0+1);
				mov		ebx, j1
				sub		ebx, j0
				inc		ebx
				mov		ecx, i1
				sub		ecx, i0
				inc		ecx
				imul	ecx, ebx
				cdq
				idiv	ecx				; result is in eax
				mov		[edi], al		; dst[0]=(uchar)sum; (lower part of AX register)
				mov		eax, sum2
				cdq
				idiv	ecx
				mov		[edi+1], al
				mov		eax, sum3
				cdq
				idiv	ecx
				mov		[edi+2], al
				////////////////////////////
				//pop		edx				; don't forget to pop
				//pop		ecx				; don't forget to pop
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		Enter_Loop2_c178
				ExitLoop2_c178:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_a_stuzz
				ExitLoop1_a_stuzz:
				jmp		CLEAR_IF_1023
				//32 bit section
				/*for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i1>=heightin)
						i1=heightin-1;
					//i1=(i+1)*sy-EPSILON;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						dst=dataout+(i*widthout+j)*4;
						//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
						sum=0;
						sum2=0;
						sum3=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+(ii*widthin+jj)*4));
								sum2+=sint(*(datain+(ii*widthin+jj)*4+1));
								sum3+=sint(*(datain+(ii*widthin+jj)*4+2));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						sum2/=(j1-j0+1)*(i1-i0+1);
						sum3/=(j1-j0+1)*(i1-i0+1);
						dst[0]=(uchar)sum;
						dst[1]=(uchar)sum2;
						dst[2]=(uchar)sum3;
					}
				}*/
				ThirtyTwoBits_xcd99:
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoop1_a_stuzz_32
				EnterLoop1_a_stuzz_32:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	i0			; store as integer
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		Skipper_tyui_32
				dec		ebx
				mov		i1, ebx
				jmp		Skipper_tyui2_32
				Skipper_tyui_32:
				mov		i1, eax
				Skipper_tyui2_32:
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_c178_32
				Enter_Loop2_c178_32:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	j0
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		Skipper_tyui_zz_32
				dec		ebx
				mov		j1, ebx
				jmp		Skipper_tyui_zz2_32
				Skipper_tyui_zz_32:
				mov		j1, eax
				Skipper_tyui_zz2_32:
				mov		edi, i
				imul	edi, widthout
				add		edi, edx		; edx contains j
				imul	edi, 4
				add		edi, dataout
				//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
				//push	ecx				; need this for looping and is ii
				//push	edx				; need this for looping and is jj
				xor		ebx, ebx		; need for computing sum
				mov		sum, 0			; sum=0
				mov		sum2, 0
				mov		sum3, 0
				mov		sum4, 0
				mov		ecx, i0
				cmp		ecx, i1
				jg		Exit_rtt1_32
				Enter_rtt1_32:
				mov		edx, j0
				cmp		edx, j1
				jg		Exit_rtt2_32
				Enter_rtt2_32:
				mov		esi, ecx
				imul	esi, widthin
				add		esi, edx
				imul	esi, 4
				add		esi, datain
				mov		bl, [esi]				; sum+=sint(*(datain+(ii*widthin+jj)*4));
				add		sum, ebx
				mov		bl, [esi+1]
				add		sum2, ebx
				mov		bl, [esi+2]
				add		sum3, ebx
				mov		bl, [esi+3]
				add		sum4, ebx
				inc		edx
				cmp		edx, j1
				jle		Enter_rtt2_32
				Exit_rtt2_32:
				inc		ecx
				cmp		ecx, i1
				jle		Enter_rtt1_32
				Exit_rtt1_32:
				mov		eax, sum		; sum/=(j1-j0+1)*(i1-i0+1);
				mov		ebx, j1
				sub		ebx, j0
				inc		ebx
				mov		ecx, i1
				sub		ecx, i0
				inc		ecx
				imul	ecx, ebx
				cdq
				idiv	ecx				; result is in eax
				mov		[edi], al		; dst[0]=(uchar)sum; (lower part of AX register)
				mov		eax, sum2
				cdq
				idiv	ecx
				mov		[edi+1], al
				mov		eax, sum3
				cdq
				idiv	ecx
				mov		[edi+2], al
				mov		eax, sum4
				cdq
				idiv	ecx
				mov		[edi+3], al
				////////////////////////////
				//pop		edx				; don't forget to pop
				//pop		ecx				; don't forget to pop
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		Enter_Loop2_c178_32
				ExitLoop2_c178_32:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_a_stuzz_32
				ExitLoop1_a_stuzz_32:
				CLEAR_IF_1023:

				Skip_Bunch_11:
			}

			/*if(components==3)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i0+1>=heightin)
						i1=heightin-1;
					else
						i1=i0+1;
					//i1=(i+1)*sy-EPSILON;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						dst=dataout+(i*widthout+j)*3;
						//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
						sum=0;
						sum2=0;
						sum3=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+(ii*widthin+jj)*3));
								sum2+=sint(*(datain+(ii*widthin+jj)*3+1));
								sum3+=sint(*(datain+(ii*widthin+jj)*3+2));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						sum2/=(j1-j0+1)*(i1-i0+1);
						sum3/=(j1-j0+1)*(i1-i0+1);
						dst[0]=(uchar)sum;
						dst[1]=(uchar)sum2;
						dst[2]=(uchar)sum3;
					}
				}
			}
			else if(components==4)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i1>=heightin)
						i1=heightin-1;
					//i1=(i+1)*sy-EPSILON;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						dst=dataout+(i*widthout+j)*4;
						//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
						sum=0;
						sum2=0;
						sum3=0;
						sum4=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+(ii*widthin+jj)*4));
								sum2+=sint(*(datain+(ii*widthin+jj)*4+1));
								sum3+=sint(*(datain+(ii*widthin+jj)*4+2));
								sum4+=sint(*(datain+(ii*widthin+jj)*4+3));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						sum2/=(j1-j0+1)*(i1-i0+1);
						sum3/=(j1-j0+1)*(i1-i0+1);
						sum4/=(j1-j0+1)*(i1-i0+1);
						dst[0]=(uchar)sum;
						dst[1]=(uchar)sum2;
						dst[2]=(uchar)sum3
						dst[3]=(uchar)sum4
					}
				}
			}*/
		}
	}	//if(dataAlignment==1)
	else if(dataAlignment==4)
	{
		//If widthin is not divisible by 4, then padding bytes will be used
		int scanLinePaddedIn;
		//If widthout is not divisible by 4, then padding bytes will be used
		int scanLinePaddedOut;
		if(isUseLinearOrPointSample==false)
		{
			//Gone use point sampling
			////////// DEBUG start /////////////////////////
			//Memory bounds check
			/*uchar *checking001, *checking002;
			checking001=datain+widthin*heightin*3;
			checking002=dataout+widthout*heightout*3;

			for(i=0; i<heightout; i++)
			{
				ii=i*sy;
				for(j=0; j<widthout; j++)
				{
					jj=j*sx;
					uchar *src=datain+(ii*widthin+jj)*components;
					uchar *dst=dataout+(i*widthout+j)*components;
					for(k=0; k<components; k++)
					{
						if(dst>=checking002)
						{
							MessageBox("Memory bound error (009zx)", "DEBUG", MB_OK);
							return 0;
						}
						if(src>=checking001)
						{
							MessageBox("Memory bound error (010zx)", "DEBUG", MB_OK);
							return 0;
						}
						*dst=*src;
						dst++;
						src++;
					}
				}
			}
			return 1;
			////////// DEBUG end /////////////////////////*/
			//Gone use point sampling
			/*if(components==3)
			{
				scanLinePaddedIn=((widthin*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				scanLinePaddedOut=((widthout*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				for(i=0; i<heightout; i++)
				{
					ii=sint(sreal(i)*sy);
					for(j=0; j<widthout; j++)
					{
						jj=sint(sreal(j)*sx);
						
						uchar *src=datain+ii*scanLinePaddedIn+jj*3;
						uchar *dst=dataout+i*scanLinePaddedOut+j*3;
						//For each component
						dst[0]=src[0];
						dst[1]=src[1];
						dst[2]=src[2];
					}
				}
			}
			else if(components==4)
			{
				scanLinePaddedIn=((widthin*4+dataAlignment-1)/dataAlignment)*dataAlignment;
				scanLinePaddedOut=((widthout*4+dataAlignment-1)/dataAlignment)*dataAlignment;
				for(i=0; i<heightout; i++)
				{
					ii=sint(sreal(i)*sy);
					for(j=0; j<widthout; j++)
					{
						jj=sint(sreal(j)*sx);
						uchar *src=datain+ii*scanLinePaddedIn+jj*4;
						uchar *dst=dataout+i*scanLinePaddedOut+j*4;
						//For each component
						dst[0]=src[0];
						dst[1]=src[1];
						dst[2]=src[2];
						dst[3]=src[3];
					}
				}
			}*/

			__asm
			{
				//ebx is dataout
				//ecx as i
				//edx as j
				mov		ebx, dataout
				cmp		components, 3
				jne		ThirtyTwoBits_Secondary5000
				//This is the 24 bit version
				//scanLinePaddedIn=((widthin*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthin
				mov		ecx, dataAlignment
				imul	eax, 3
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx					; result is in eax
				imul	eax, ecx
				mov		scanLinePaddedIn, eax
				//scanLinePaddedOut=((widthout*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthout
				imul	eax, 3
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx
				imul	eax, ecx
				mov		scanLinePaddedOut, eax

				//Do 32 bit copying except for last line where we do 16 + 8 bit to
				//avoid boundary over flow
				mov		eax, heightout
				dec		eax
				mov		heightout, eax

				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoops_Secondary5000
				EnterLoop1_Secondary5000:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	ii
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoops_Secondary5000
				EnterLoop2_Secondary5000:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	jj
				mov		esi, ii
				imul	esi, scanLinePaddedIn
				mov		eax, jj
				imul	eax, 3
				add		esi, eax
				add		esi, datain
				mov		edi, i
				imul	edi, scanLinePaddedOut
				mov		eax, edx		; edx contains j
				imul	eax, 3
				add		edi, eax		
				add		edi, ebx
				mov		eax, [esi]
				mov		[edi], eax			; copy 4 bytes, 32 bits
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2_Secondary5000
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_Secondary5000

				//Process the last line of this 24 bit image
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	ii
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoops_Secondary5000
				EnterLoop2_Secondary5000_bbnn:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	jj
				mov		esi, ii
				imul	esi, scanLinePaddedIn
				mov		eax, jj
				imul	eax, 3
				add		esi, eax
				add		esi, datain
				mov		edi, i
				imul	edi, scanLinePaddedOut
				mov		eax, edx		; edx contains j
				imul	eax, 3
				add		edi, eax		
				add		edi, ebx
				mov		ax, word ptr[esi]
				mov		word ptr[edi], ax			; copy 4 bytes, 32 bits
				mov		al, byte ptr[esi+2]
				mov		byte ptr[edi+2], al
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2_Secondary5000_bbnn

				jmp		ExitLoops_Secondary5000		; skip 32 bit section

				ThirtyTwoBits_Secondary5000:
				//This is the 32 bit version
				//scanLinePaddedIn=((widthin*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthin
				mov		ecx, dataAlignment
				imul	eax, 4
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx					; result is in eax
				imul	eax, ecx
				mov		scanLinePaddedIn, eax
				//scanLinePaddedOut=((widthout*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthout
				imul	eax, 4
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx
				imul	eax, ecx
				mov		scanLinePaddedOut, eax

				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoops_Secondary5000
				EnterLoop1b_Secondary5000:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	ii
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop1b_Secondary5000
				EnterLoop2b_Secondary5000:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	jj
				mov		esi, ii
				imul	esi, scanLinePaddedIn
				mov		eax, jj
				imul	eax, 4
				add		esi, eax
				add		esi, datain
				mov		edi, ecx		; contains i
				imul	edi, scanLinePaddedOut
				mov		eax, edx		; contains j
				imul	eax, 4
				add		edi, eax		
				add		edi, ebx
				mov		eax, [esi]		; copy color, 32 bit move
				mov		[edi], eax
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2b_Secondary5000
				ExitLoop1b_Secondary5000:
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1b_Secondary5000
				ExitLoops_Secondary5000:
			}
			
			//return 1;			//Success
			goto EndOf_glhScaleImage_asm386;
		}
		else //if(isUseLinearOrPointSample==TRUE)
		{
			//Magnify both width and height:  use weighted sample of 4 pixels
			//**** In this code, floating point is used to do some of the calculations, but I will avoid
			//**** using the FPU and will stick to integer computation with some limited precision.
			int i0, i1, j0, j1, sum, sum2, sum3, sum4;
			//sint alpha, beta;		//These are suppose to be sreal in MESA code!
			float falpha, fbeta, foneminusalpha, foneminusbeta;//, s1, s2;
			unsigned char *src00, *src01, *src10, *src11;
			//uchar *check=dataout+widthout*heightout*components;
			//uchar *check2=datain+widthin*heightin*components;

			__asm
			{
				//if((sx<1.0)&&(sy<1.0))
				fld		sx
				fcomp	one
				fnstsw	ax
				test	ah, 5
				jp		SkipIf_98_Secondary5000
				fld		sy
				fcomp	one
				fnstsw	ax
				test	ah, 5
				jp		SkipIf_98_Secondary5000
			}

			__asm
			{
				//ecx is i
				//edx is j
				cmp		components, 3
				jne		ThirtyTwoBits_66_78_Secondary5000
				//24 bit section
				//scanLinePaddedIn=((widthin*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthin
				mov		ecx, dataAlignment
				imul	eax, 3
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx					; result is in eax
				imul	eax, ecx
				mov		scanLinePaddedIn, eax
				//scanLinePaddedOut=((widthout*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthout
				imul	eax, 3
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx
				imul	eax, ecx
				mov		scanLinePaddedOut, eax

				fld		one				; need this for later (1.0-falpha and 1.0 fbeta)
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitSuperly_Secondary5000
				EnterLoop1_dashj_Secondary5000:
				mov		i, ecx
				fild	i
				fmul	sy				; i0=sint(sreal(i)*sy);
				fist	i0				; keep the value in FPU register for later 
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_a_Secondary5000
				dec		ebx
				mov		i1, ebx
				jmp		SkipIfStatement_firett_b_Secondary5000
				SkipIfStatement_firett_a_Secondary5000:
				mov		i1, eax
				SkipIfStatement_firett_b_Secondary5000:
				fisub	i0					; this is falpha in st(0) - falpha=sreal(i)*sy-sreal(i0);
				fst		falpha
				fsub	st(0), st(1)		; this is foneminusalpha in st(0)
				fchs						; must change the sign
				fstp	foneminusalpha
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_sippy_Secondary5000
				EnterLoop2_sippy_Secondary5000:
				mov		j, edx
				fild	j
				fmul	sx				; sreal(j)*sx
				fist	j0				; keep this in FPU register for later
				//if(j0+1>=widthin)
				//	j1=widthin-1;
				//else
				//	j1=j0+1;
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_c_Secondary5000
				dec		ebx
				mov		j1, ebx
				jmp		SkipIfStatement_firett_d_Secondary5000
				SkipIfStatement_firett_c_Secondary5000:
				mov		j1, eax
				SkipIfStatement_firett_d_Secondary5000:
				fisub	j0
				fst		fbeta
				fsub	st(0), st(1)		; this is foneminusbeta in st(0)
				fchs						; must change the sign
				fstp	foneminusbeta
				//Now esi is src00
				//Now edi is src01
				//Now ebx is src10
				//Now ecx is src11
				//push	edx					; for safekeeping
				//push	ecx					; for safekeeping
				/*src00=datain+i0*scanLinePaddedIn+j0*3;
				src01=datain+i0*scanLinePaddedIn+j1*3;
				src10=datain+i1*scanLinePaddedIn+j0*3;
				src11=datain+i1*scanLinePaddedIn+j1*3;
				dst=dataout+i*scanLinePaddedOut+j*3;*/
				mov		eax, j0				; not enough registers
				imul	eax, 3
				mov		j0, eax
				mov		eax, j1				; not emough registers
				imul	eax, 3
				mov		j1, eax
				mov		eax, datain			; temporary (not enough registers to make this algorithm efficient)
				mov		esi, i0
				imul	esi, scanLinePaddedIn
				mov		edi, esi			; make a copy of i0*scanLinePaddedIn for efficiency
				add		esi, j0
				add		esi, eax
				add		edi, j1
				add		edi, eax
				mov		ebx, i1
				imul	ebx, scanLinePaddedIn
				mov		ecx, ebx			; make a copy of i1*scanLinePaddedIn for efficiency
				add		ebx, j0
				add		ebx, eax
				add		ecx, j1
				add		ecx, eax
				mov		eax, i				; dst=dataout+i*scabLinePaddedOut+j*3;
				imul	eax, scanLinePaddedOut
				imul	edx, 3
				add		eax, edx			; edx is j in this case (j is a backup)
				add		eax, dataout
				mov		edx, eax			; now we have address in dst or in this case, edx
				mov		src00, esi
				mov		src01, edi
				mov		src10, ebx
				mov		src11, ecx
				//dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
				//			(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[0]*foneminusbeta
				mov		al, [edi]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[0]*foneminusbeta
				mov		al, [ecx]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx], al	; dst[0] contains result now
				//dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
				//			(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[1]*foneminusbeta
				mov		al, [edi+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[1]*foneminusbeta
				mov		al, [ecx+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+1], al	; dst[1] contains result now
				//dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
				//			(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[2]*foneminusbeta
				mov		al, [edi+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[2]*foneminusbeta
				mov		al, [ecx+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+2], al	; dst[2] contains result now
				///////////
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2_sippy_Secondary5000
				ExitLoop2_sippy_Secondary5000:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_dashj_Secondary5000
				jmp		ExitSuperly_Secondary5000
				//32 bit section
				ThirtyTwoBits_66_78_Secondary5000:
				//scanLinePaddedIn=((widthin*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthin
				mov		ecx, dataAlignment
				imul	eax, 4
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx					; result is in eax
				imul	eax, ecx
				mov		scanLinePaddedIn, eax
				//scanLinePaddedOut=((widthout*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthout
				imul	eax, 4
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx
				imul	eax, ecx
				mov		scanLinePaddedOut, eax

				fld		one				; need this for later (1.0-falpha and 1.0 fbeta)
				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitSuperly_Secondary5000
				EnterLoop1_dashj_b_Secondary5000:
				mov		i, ecx
				fild	i
				fmul	sy
				fist	i0				; keep the value in FPU register for later
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_a_b_Secondary5000
				dec		ebx
				mov		i1, ebx
				jmp		SkipIfStatement_firett_b_b_Secondary5000
				SkipIfStatement_firett_a_b_Secondary5000:
				mov		i1, eax
				SkipIfStatement_firett_b_b_Secondary5000:
				fisub	i0					; this is falpha in st(0)
				fst		falpha
				fsub	st(0), st(1)		; this is foneminusalpha in st(0)
				fchs						; must change the sign
				fstp	foneminusalpha
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_sippy_b_Secondary5000
				EnterLoop2_sippy_b_Secondary5000:
				mov		j, edx
				fild	j
				fmul	sx
				fist	j0				; keep this in FPU register for later
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		SkipIfStatement_firett_c_b_Secondary5000
				dec		ebx
				mov		j1, ebx
				jmp		SkipIfStatement_firett_d_b_Secondary5000
				SkipIfStatement_firett_c_b_Secondary5000:
				mov		j1, eax
				SkipIfStatement_firett_d_b_Secondary5000:
				fisub	j0
				fst		fbeta
				fsub	st(0), st(1)		; this is foneminusbeta in st(0)
				fchs						; must change the sign
				fstp	foneminusbeta
				//Now esi is src00
				//Now edi is src01
				//Now ebx is src10
				//Now ecx is src11
				mov		eax, j0				; not enough registers
				imul	eax, 4
				mov		j0, eax
				mov		eax, j1				; not enough registers
				imul	eax, 4
				mov		j1, eax
				mov		eax, datain			; temporary (not enough registers to make this algorithm efficient)
				mov		esi, i0
				imul	esi, scanLinePaddedIn
				mov		edi, esi			; make a copy of i0*scanLinePaddedIn for efficiency
				add		esi, j0
				add		esi, eax
				add		edi, j1
				add		edi, eax
				mov		ebx, i1
				imul	ebx, scanLinePaddedIn
				mov		ecx, ebx			; make a copy if i1*sanLinePaddedIn for efficiency
				add		ebx, j0
				add		ebx, eax
				add		ecx, j1
				add		ecx, eax
				mov		eax, i				; dst=dataout+i*scanLinePaddedOut+j*4;
				imul	eax, scanLinePaddedOut
				imul	edx, 4
				add		eax, edx			; edx is j
				add		eax, dataout
				mov		edx, eax			; now we have address in dst
				//dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
				//			(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
				xor		eax, eax
				mov		al, [esi]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[0]*foneminusbeta
				mov		al, [edi]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[0]*foneminusbeta
				mov		al, [ecx]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[0]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx], al	; dst[0] contains result now
				//dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
				//			(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;				
				mov		al, [esi+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[1]*foneminusbeta
				mov		al, [edi+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+1]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[1]*foneminusbeta
				mov		al, [ecx+1]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[1]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+1], al	; dst[1] contains result now
				mov		byte ptr[edx+1], al	; dst[1] contains result now
				//dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
				//			(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
				mov		al, [esi+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[2]*foneminusbeta
				mov		al, [edi+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+2]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[2]*foneminusbeta
				mov		al, [ecx+2]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[2]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+2], al	; dst[2] contains result now
				//dst[3]=(src00[3]*foneminusbeta+src01[3]*fbeta)*foneminusalpha+
				//			(src10[3]*foneminusbeta+src11[3]*fbeta)*falpha;
				mov		al, [esi+3]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src00[3]*foneminusbeta
				mov		al, [edi+3]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src01[3]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	foneminusalpha		; *foneminusalpha
				mov		al, [ebx+3]
				mov		tempo, eax
				fild	tempo
				fmul	foneminusbeta		; src10[3]*foneminusbeta
				mov		al, [ecx+3]
				mov		tempo, eax
				fild	tempo
				fmul	fbeta				; src11[3]*fbeta
				faddp	st(1), st(0)		; add them together
				fmul	falpha				; *falpha
				faddp	st(1), st(0)		; finally, add both parts to finish
				fistp	tempo				; store result in 32 bit integer
				mov		eax, tempo
				mov		byte ptr[edx+3], al	; dst[3] contains result now
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		EnterLoop2_sippy_b_Secondary5000
				ExitLoop2_sippy_b_Secondary5000:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_dashj_b_Secondary5000
				ExitSuperly_Secondary5000:
				fstp	st(0)
				//finit			; a single pop would suffice here

				jmp		Skip_Bunch_11_Secondary5000
			}
			/*if(components==3)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					if(i0+1>=heightin)
						i1=heightin-1;
					else
						i1=i0+1;
					//i1=(i+1)*sy-EPSILON;
					falpha=sreal(i)*sy-sreal(i0);
					foneminusalpha=1.0-falpha;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						if(j0+1>=widthin)
							j1=widthin-1;
						else
							j1=j0+1;
						//j1=(j+1)*sx-EPSILON;
						fbeta=sreal(j)*sx-sreal(j0);
						foneminusbeta=1.0-fbeta;
						//Compute weighted average of pixels in rect (i0,j0)-(i1,j1)
						src00=datain+i0*scanLinePaddedIn+j0*3;
						src01=datain+i0*scanLinePaddedIn+j1*3;
						src10=datain+i1*scanLinePaddedIn+j0*3;
						src11=datain+i1*scanLinePaddedIn+j1*3;
						dst=dataout+i*scanLinePaddedOut+j*3;
						//For each component	
						
						dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
							(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
						
						dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
							(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;
						
						dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
							(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
					}
				}
			}
			else if(components==4)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i1>=heightin)
						i1=heightin-1;
					//i1=(i+1)*sy-EPSILON;
					falpha=sreal(i)*sy-sreal(i0);
					foneminusalpha=1.0-falpha;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						fbeta=sreal(j)*sx-sreal(j0);
						foneminusbeta=1.0-fbeta;
						//Compute weighted average of pixels in rect (i0,j0)-(i1,j1)
						src00=datain+i0*scanLinePaddedIn+j0*4;
						src01=datain+i0*scanLinePaddedIn+j1*4;
						src10=datain+i1*scanLinePaddedIn+j0*4;
						src11=datain+i1*scanLinePaddedIn+j1*4;
						dst=dataout+i*scanLinePaddedOut+j*4;
						//For each component	
						dst[0]=(src00[0]*foneminusbeta+src01[0]*fbeta)*foneminusalpha+
							(src10[0]*foneminusbeta+src11[0]*fbeta)*falpha;
						
						dst[1]=(src00[1]*foneminusbeta+src01[1]*fbeta)*foneminusalpha+
							(src10[1]*foneminusbeta+src11[1]*fbeta)*falpha;
						
						dst[2]=(src00[2]*foneminusbeta+src01[2]*fbeta)*foneminusalpha+
							(src10[2]*foneminusbeta+src11[2]*fbeta)*falpha;
						
						dst[3]=(src00[3]*foneminusbeta+src01[3]*fbeta)*foneminusalpha+
							(src10[3]*foneminusbeta+src11[3]*fbeta)*falpha;
					}
				}
			}*/
			//Shrink width and/or height:  use an unweighted box filter
			_asm
			{
				SkipIf_98_Secondary5000:
				//ecx is i
				//edx is j
				cmp		components, 3
				jne		ThirtyTwoBits_xcd99_Secondary5000
				//24 bit section
				//scanLinePaddedIn=((widthin*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthin
				mov		ecx, dataAlignment
				imul	eax, 3
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx					; result is in eax
				imul	eax, ecx
				mov		scanLinePaddedIn, eax
				//scanLinePaddedOut=((widthout*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthout
				imul	eax, 3
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx
				imul	eax, ecx
				mov		scanLinePaddedOut, eax

				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoop1_a_stuzz_Secondary5000
				EnterLoop1_a_stuzz_Secondary5000:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	i0			; store as integer
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		Skipper_tyui_Secondary5000
				dec		ebx
				mov		i1, ebx
				jmp		Skipper_tyui2_Secondary5000
				Skipper_tyui_Secondary5000:
				mov		i1, eax
				Skipper_tyui2_Secondary5000:
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_c178_Secondary5000
				Enter_Loop2_c178_Secondary5000:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	j0
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		Skipper_tyui_zz_Secondary5000
				dec		ebx
				mov		j1, ebx
				jmp		Skipper_tyui_zz2_Secondary5000
				Skipper_tyui_zz_Secondary5000:
				mov		j1, eax
				Skipper_tyui_zz2_Secondary5000:
				mov		edi, i
				imul	edi, scanLinePaddedOut
				mov		eax, edx		; edx contains j
				imul	eax, 3
				add		edi, eax
				add		edi, dataout
				//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
				//push	ecx				; need this for looping and is ii
				//push	edx				; need this for looping and is jj
				xor		ebx, ebx		; need for computing sum
				mov		sum, 0			; sum=0
				mov		sum2, 0
				mov		sum3, 0
				mov		sum4, 0
				mov		ecx, i0
				cmp		ecx, i1
				jg		Exit_rtt1_Secondary5000
				Enter_rtt1_Secondary5000:
				mov		edx, j0
				cmp		edx, j1
				jg		Exit_rtt2_Secondary5000
				Enter_rtt2_Secondary5000:
				mov		esi, ecx
				imul	esi, scanLinePaddedIn
				mov		eax, edx
				imul	eax, 3
				add		esi, eax
				add		esi, datain
				mov		bl, [esi]				; sum+=sint(*(datain+ii*scanLinePaddedIn+jj*3));
				add		sum, ebx
				mov		bl, [esi+1]
				add		sum2, ebx
				mov		bl, [esi+2]
				add		sum3, ebx
				inc		edx
				cmp		edx, j1
				jle		Enter_rtt2_Secondary5000
				Exit_rtt2_Secondary5000:
				inc		ecx
				cmp		ecx, i1
				jle		Enter_rtt1_Secondary5000
				Exit_rtt1_Secondary5000:
				mov		eax, sum		; sum/=(j1-j0+1)*(i1-i0+1);
				mov		ebx, j1
				sub		ebx, j0
				inc		ebx
				mov		ecx, i1
				sub		ecx, i0
				inc		ecx
				imul	ecx, ebx
				cdq
				idiv	ecx				; result is in eax
				mov		[edi], al		; dst[0]=(uchar)sum; (lower part of AX register)
				mov		eax, sum2
				cdq
				idiv	ecx
				mov		[edi+1], al
				mov		eax, sum3
				cdq
				idiv	ecx
				mov		[edi+2], al
				////////////////////////////
				//pop		edx				; don't forget to pop
				//pop		ecx				; don't forget to pop
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		Enter_Loop2_c178_Secondary5000
				ExitLoop2_c178_Secondary5000:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_a_stuzz_Secondary5000
				ExitLoop1_a_stuzz_Secondary5000:
				jmp		CLEAR_IF_1023_Secondary5000
				//32 bit section
				/*for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i1>=heightin)
						i1=heightin-1;
					//i1=(i+1)*sy-EPSILON;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						dst=dataout+i*scanLinePaddedOut+j*4;
						//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
						sum=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+ii*scanLinePaddedIn+jj*4));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						dst[0]=(uchar)sum;
						sum=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+ii*scanLinePaddedIn+jj*4+1));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						dst[1]=(uchar)sum;
						sum=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+ii*scanLinePaddedIn+jj*4+2));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						dst[2]=(uchar)sum;
						sum=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+ii*scanLinePaddedIn+jj*4+3));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						dst[2]=(uchar)sum;
					}
				}*/
				ThirtyTwoBits_xcd99_Secondary5000:
				//scanLinePaddedIn=((widthin*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthin
				mov		ecx, dataAlignment
				imul	eax, 4
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx					; result is in eax
				imul	eax, ecx
				mov		scanLinePaddedIn, eax
				//scanLinePaddedOut=((widthout*3+dataAlignment-1)/dataAlignment)*dataAlignment;
				mov		eax, widthout
				imul	eax, 4
				add		eax, ecx
				dec		eax
				cdq
				idiv	ecx
				imul	eax, ecx
				mov		scanLinePaddedOut, eax

				xor		ecx, ecx
				cmp		ecx, heightout
				jge		ExitLoop1_a_stuzz_32_Secondary5000
				EnterLoop1_a_stuzz_32_Secondary5000:
				mov		i, ecx
				fild	i
				fmul	sy
				fistp	i0			; store as integer
				mov		eax, i0
				inc		eax
				mov		ebx, heightin
				cmp		eax, ebx
				jl		Skipper_tyui_32_Secondary5000
				dec		ebx
				mov		i1, ebx
				jmp		Skipper_tyui2_32_Secondary5000
				Skipper_tyui_32_Secondary5000:
				mov		i1, eax
				Skipper_tyui2_32_Secondary5000:
				xor		edx, edx
				cmp		edx, widthout
				jge		ExitLoop2_c178_32_Secondary5000
				Enter_Loop2_c178_32_Secondary5000:
				mov		j, edx
				fild	j
				fmul	sx
				fistp	j0
				mov		eax, j0
				inc		eax
				mov		ebx, widthin
				cmp		eax, ebx
				jl		Skipper_tyui_zz_32_Secondary5000
				dec		ebx
				mov		j1, ebx
				jmp		Skipper_tyui_zz2_32_Secondary5000
				Skipper_tyui_zz_32_Secondary5000:
				mov		j1, eax
				Skipper_tyui_zz2_32_Secondary5000:
				mov		edi, i
				imul	edi, scanLinePaddedOut
				mov		eax, edx		; edx contains j
				imul	eax, 4
				add		edi, eax
				add		edi, dataout
				//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
				//push	ecx				; need this for looping and is ii
				//push	edx				; need this for looping and is jj
				xor		ebx, ebx		; need for computing sum
				mov		sum, 0			; sum=0
				mov		sum2, 0
				mov		sum3, 0
				mov		sum4, 0
				mov		ecx, i0
				cmp		ecx, i1
				jg		Exit_rtt1_32_Secondary5000
				Enter_rtt1_32_Secondary5000:
				mov		edx, j0
				cmp		edx, j1
				jg		Exit_rtt2_32_Secondary5000
				Enter_rtt2_32_Secondary5000:
				mov		esi, ecx
				imul	esi, scanLinePaddedIn
				mov		eax, edx
				imul	eax, 4
				add		esi, eax
				add		esi, datain
				mov		bl, [esi]				; sum+=sint(*(datain+ii*scanLinePaddedIn+jj*4));
				add		sum, ebx
				mov		bl, [esi+1]
				add		sum2, ebx
				mov		bl, [esi+2]
				add		sum3, ebx
				mov		bl, [esi+3]
				add		sum4, ebx
				inc		edx
				cmp		edx, j1
				jle		Enter_rtt2_32_Secondary5000
				Exit_rtt2_32_Secondary5000:
				inc		ecx
				cmp		ecx, i1
				jle		Enter_rtt1_32_Secondary5000
				Exit_rtt1_32_Secondary5000:
				mov		eax, sum		; sum/=(j1-j0+1)*(i1-i0+1);
				mov		ebx, j1
				sub		ebx, j0
				inc		ebx
				mov		ecx, i1
				sub		ecx, i0
				inc		ecx
				imul	ecx, ebx
				cdq
				idiv	ecx				; result is in eax
				mov		[edi], al		; dst[0]=(uchar)sum; (lower part of AX register)
				mov		eax, sum2
				cdq
				idiv	ecx
				mov		[edi+1], al
				mov		eax, sum3
				cdq
				idiv	ecx
				mov		[edi+2], al
				mov		eax, sum4
				cdq
				idiv	ecx
				mov		[edi+3], al
				
				////////////////////////////
				//pop		edx				; don't forget to pop
				//pop		ecx				; don't forget to pop
				mov		edx, j
				inc		edx
				cmp		edx, widthout
				jl		Enter_Loop2_c178_32_Secondary5000
				ExitLoop2_c178_32_Secondary5000:
				mov		ecx, i
				inc		ecx
				cmp		ecx, heightout
				jl		EnterLoop1_a_stuzz_32_Secondary5000
				ExitLoop1_a_stuzz_32_Secondary5000:
				CLEAR_IF_1023_Secondary5000:

				Skip_Bunch_11_Secondary5000:
			}

			/*if(components==3)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i0+1>=heightin)
						i1=heightin-1;
					else
						i1=i0+1;
					//i1=(i+1)*sy-EPSILON;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						dst=dataout+i*scanLinePaddedOut+j*3;
						//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
						sum=0;
						sum2=0;
						sum3=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+ii*scanLinePaddedIn+jj*3));
								sum2+=sint(*(datain+ii*scanLinePaddedIn+jj*3+1));
								sum3+=sint(*(datain+ii*scanLinePaddedIn+jj*3+2));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						sum2/=(j1-j0+1)*(i1-i0+1);
						sum3/=(j1-j0+1)*(i1-i0+1);
						dst[0]=(uchar)sum;
						dst[1]=(uchar)sum2;
						dst[2]=(uchar)sum3;
					}
				}
			}
			else if(components==4)
			{
				for(i=0; i<heightout; i++)
				{
					i0=sint(sreal(i)*sy);
					i1=i0+1;
					if(i1>=heightin)
						i1=heightin-1;
					//i1=(i+1)*sy-EPSILON;
					for(j=0; j<widthout; j++)
					{
						j0=sint(sreal(j)*sx);
						j1=j0+1;
						if(j1>=widthin)
							j1=widthin-1;
						//j1=(j+1)*sx-EPSILON;
						dst=dataout+i*scanLinePaddedOut+j*4;
						//Compute average of pixels in the rectangle (i0,j0)-(i1,j1)
						sum=0;
						sum2=0;
						sum3=0;
						sum4=0;
						for(ii=i0; ii<=i1; ii++)
						{
							for(jj=j0; jj<=j1; jj++)
							{
								sum+=sint(*(datain+ii*scanLinePaddedIn+jj*4));
								sum2+=sint(*(datain+ii*scanLinePaddedIn+jj*4+1));
								sum3+=sint(*(datain+ii*scanLinePaddedIn+jj*4+2));
								sum4+=sint(*(datain+ii*scanLinePaddedIn+jj*4+3));
							}
						}
						sum/=(j1-j0+1)*(i1-i0+1);
						sum2/=(j1-j0+1)*(i1-i0+1);
						sum3/=(j1-j0+1)*(i1-i0+1);
						sum4/=(j1-j0+1)*(i1-i0+1);
						dst[0]=(uchar)sum;
						dst[1]=(uchar)sum2;
						dst[2]=(uchar)sum3;
						dst[3]=(uchar)sum4;
					}
				}
			}*/
		}
	}	//if(dataAlignment==4)
	else
	{
		//Don't forget to restore FPU state completly (the control register)
		__asm
		{
			fldcw	old_FPU_Flag	; load control word
		}
		return -5;		//Other data alignment are not implemented
	}

	EndOf_glhScaleImage_asm386:

	//Don't forget to restore FPU state completly (the control register)
	__asm
	{
		fldcw	old_FPU_Flag	; load control word
	}
	return 1;	//Success
}


bool ZoomOutTwice::ReduceImageByHalf()
{

	if(firsttime)
	{
		DataOut = (unsigned char*)malloc(4 * (width*height) * sizeof(unsigned char));
    	DataOut = DataIn;

		width_new = width/2;
		height_new = height/2;
		if (SizeEnd < 1) SizeEnd = 1;
	    firsttime = false;
	}
	else
	{
	    if (SizeEnd == width || SizeEnd == height) 
		{
			DataUsing = nullptr;
			DataOut   = nullptr;
			return false;
	    }

	    level = level + 1;

	    int x;

    	if(z_bool)
    	{
    	    DataUsing = (unsigned char*)malloc(4 * (width_new*height_new) * sizeof(unsigned char));

	        x = gluScaleImage(format,
                            width,
                            height,
                            DataIn,
                            width_new,
                            height_new,
                            DataUsing);

	       if((x==0)||(x==-5)) 			
		   {
			  DataUsing = nullptr;
			  DataOut   = nullptr;
			  return false;
	       }

		   width   = width_new;
	       height  = height_new;

	       DataOut = (unsigned char*)malloc(4 * (width_new*height_new) * sizeof(unsigned char));
	       DataOut = DataUsing;
	       z_bool=false;
	    }
	    else
	    {
            DataIn = (unsigned char*)malloc(4 * (width_new*height_new) * sizeof(unsigned char));
	        x = gluScaleImage(format,
                             width,
                             height,
                             DataUsing,
                             width_new,
                             height_new,
                             DataIn);

	        if((x==0)||(x==-5))
	        {
			    DataUsing = nullptr;
		    	DataOut   = nullptr;
		        return false;
	        }

	        width   = width_new;
	        height  = height_new;
	        DataOut = (unsigned char*)malloc(4 * (width_new*height_new) * sizeof(unsigned char));
	        DataOut = DataIn;

	        z_bool=true;
	    }

	    width_new  = width_new/2;
	    height_new = height_new/2;
	}
	return true;
}

